
--Script: RegionToll
--Version: 	1.0
--Author:	Maxis  mail:m2608@yandex.ru
/*Note: .Drawing Render Region between two points in Viewport.
If you press the  Ctrl key, So you can move the whole selection in active viewport*/
--------------------------------	
global Region_two_point
tool Region_two_point
(
local point_1, point_2, Px, Py, wd=50, hd=50, CropWin_Y, CropWin_X, Sub_X, Sub_Y, ViewWin_Y, ViewWin_Y, nv
	
fn gwHmarker_n = (
	gw.SetColor #line white
	gw.wPolyline #([point_1.x,point_1.y,0],[point_2.x,point_1.y,0],[point_2.x,point_2.y,0],[point_1.x,point_2.y,0]) true 
	gw.enlargeUpdateRect #whole
	gw.updateScreen()	
)	

fn SubSIze = ( -- Get Win Size 
	local ViewWin_Y = gw.getWinSizeY()
	local ViewWin_X = gw.getWinSizeX()
	local ImgAsp = getRendImageAspect()
	local VpAsp = ViewWin_X as float / ViewWin_Y as float	
	--------------------//----------------------
	if VpAsp > ImgAsp then(
		CropWin_X = ViewWin_Y * ImgAsp
		CropWin_Y = gw.getWinSizeY()
		Sub_X = abs ((ViewWin_X-CropWin_X)/2) 
		Sub_Y = 0
		-------------------------------------
	)
	else(
		CropWin_Y = ViewWin_X / ImgAsp
		CropWin_X = gw.getWinSizeX()
		Sub_Y = abs ((ViewWin_Y-CropWin_Y)/2) 
		Sub_X = 0
	)
)	
			
fn GetCordX_pos numb = (  -- Calculate pos x 
	a1 = numb*100/CropWin_X 
	a3 = renderWidth * a1 / 100
)	
fn GetCordY_pos numb = (  -- Calculate pos y
	a1 = numb*100/CropWin_Y
	a3 =(( renderHeight * a1 / 100)+1 )as integer
)
	
on mousePoint clickno do(
	if clickno == 1 then (
		registerRedrawViewsCallback gwHmarker_n	
		SubSIze()
		----------------------------------
		point_1 = mouse.pos
		point_2 = mouse.pos	
		-----------------------------------	
		if point_1.x < Sub_X then point_1.x = Sub_X
		if point_1.x > (Sub_X + CropWin_X) then point_1.x = Sub_X + CropWin_X+1
		
		)
	if clickno == 2 then ( 
		Px = (GetCordX_pos (point_1.x - Sub_X))as integer
		Py =( GetCordY_pos (point_1.y - Sub_Y))as integer
		wd = abs (point_2.x - point_1.x)*(RenderWidth/CropWin_X as float) --heigth Rect	
		hd = abs (point_1.y - point_2.y) * (RenderHeight/CropWin_Y as float) --width Rect	
	
		case of (
			((point_2.x < point_1.x)and(point_2.y > point_1.y) ):(Px = Px-wd) --right bottom x
			((point_2.y < point_1.y)and(point_2.x > point_1.x)):(Py = Py-hd) -- right bottom y
			((point_2.x < point_1.x) and (point_1.y > point_2.y)):(Px = Px-wd; Py = Py-hd) -- right bottom x,y
			default:print "default"
			)
			
		----------------------------
		nv = viewport.activeViewport
		rendViewIndex = nv	
		EditRenderRegion.EditRegion()
		viewport.setRegionRect nv (Box2 Px Py wd hd)
		EditRenderRegion.UpdateRegion() 
		EditRenderRegion.EditRegion()
		-------------------------------
		unregisterRedrawViewsCallback gwHmarker_n			
		#stop	
	)
)

on mouseMove clickno do (
	if ctrlKey == true then(
		case of (
			((point_2.x < point_1.x)and(point_2.y > point_1.y) ):( --right bottom x
				point_1 = [mouse.pos.x + wd,mouse.pos.y - hd] 
				point_2 = [point_1.x-wd,point_1.y+hd]
		
			) -- x
			((point_2.y < point_1.y)and(point_2.x > point_1.x)):( --right bottom y
				point_1 = [mouse.pos.x - wd,mouse.pos.y + hd] 
				point_2 = [point_1.x+wd,point_1.y-hd]

			) -- y
			((point_2.x < point_1.x) and (point_1.y > point_2.y)):( --right bottom x y
				point_1 = mouse.pos + [wd,hd]
				point_2 = [point_1.x-wd,point_1.y-hd]

			) -- x and y
			default:(
				point_1 = mouse.pos - [wd,hd]
				point_2 = [point_1.x+wd,point_1.y+hd]
			)
		)
		---------------- outside the window
		if point_1.x < Sub_X then point_1.x = Sub_X
		if point_1.y < Sub_Y then point_1.y = Sub_Y	
		if point_1.y > (Sub_Y + CropWin_Y) then point_1.y = Sub_Y + CropWin_Y+1
		if point_1.x > (Sub_X + CropWin_X) then point_1.x = Sub_X + CropWin_X+1
--------------------------------------------------------------------------------
		
		if point_2.y < Sub_Y then point_2.y = Sub_Y
		if point_2.y > (Sub_Y + CropWin_Y) then point_2.y = Sub_Y + CropWin_Y+1
		if point_2.x < Sub_X then point_2.x = Sub_X
		if point_2.x > (Sub_X + CropWin_X) then point_2.x = Sub_X + CropWin_X+1
		redrawViews()
	)
	else (
			if point_2 != undefined then (
				point_2 = mouse.pos
				wd = abs (point_2.x - point_1.x)+1	
				hd = abs (point_1.y - point_2.y) 
				-------------------------------------------------
				if point_1.x < Sub_X then point_1.x = Sub_X
				if point_1.y < Sub_Y then point_1.y = Sub_Y	
				if point_1.y > (Sub_Y + CropWin_Y) then point_1.y = Sub_Y + CropWin_Y+1
				if point_1.x > (Sub_X + CropWin_X) then point_1.x = Sub_X + CropWin_X+1				
				if point_2.y < Sub_Y then point_2.y = Sub_Y
				if point_2.y > (Sub_Y + CropWin_Y) then point_2.y = Sub_Y + CropWin_Y+1
				if point_2.x < Sub_X then point_2.x = Sub_X
				if point_2.x > (Sub_X + CropWin_X) then point_2.x = Sub_X + CropWin_X+1
					redrawViews()
				)
		)
)
on mouseAbort clickno do(
unregisterRedrawViewsCallback gwHmarker_n
	#stop
	)	
)--end tool
--if displaysafeframes != on do displaysafeframes = on
--starttool Region_two_point	
